accounts/urls.py
from django.contrib.auth import views
from django.contrib.auth.views import LoginView, LogoutView
from django.urls import path

from accounts.views import SignUpView, SubmittableLogoutView, view_profile

app_name = "accounts"
urlpatterns = [
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(), name="logout"),
    path("logout/request/", SubmittableLogoutView.as_view(), name="logout_request"),
    path("sign_up/", SignUpView.as_view(), name="sign_up"),
    path("profile/", view_profile, name="view_profile"),
]

carts/urls.py
from django.contrib.auth import views
from django.contrib.auth.views import LoginView, LogoutView
from django.urls import path

from carts.views import add_cart, cart_detail, cart_remove, full_remove

app_name = "cart"

urlpatterns = [
    path("add/<int:item_id>/", add_cart, name="add_cart"),
    path("", cart_detail, name="cart_detail"),
    path("remove/<int:product_id>/", cart_remove, name="cart_remove"),
    path("full_remove/<int:product_id>/", full_remove, name="full_remove"),
]

final_project/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

from catalogue.views import item_list, AboutView, ItemDetailView

urlpatterns = [
    path("admin/", admin.site.urls),
    path("", item_list, name="item_list"),
    path("accounts/", include("accounts.urls", namespace="accounts")),
    path("cart/", include("carts.urls", namespace="cart")),
    path("about/", AboutView.as_view(), name="about"),
    path("products/<int:pk>", ItemDetailView.as_view(), name="product"),
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

carts/models.py
from django.contrib.auth.models import User
from django.db.models import (
    Model,
    ForeignKey,
    CASCADE,
    DateTimeField,
    IntegerField,
    FloatField,
    CharField,
    BooleanField,
)
from django.utils.datetime_safe import datetime

from catalogue.models import Item


class Cart(Model):
    user = ForeignKey(User, on_delete=CASCADE)
    cart_id = CharField(max_length=250, blank=True)
    created_at = DateTimeField(default=datetime.now)

    def __str__(self):
        return self.cart_id


class CartItem(Model):
    product = ForeignKey(Item, on_delete=CASCADE)
    quantity = IntegerField(default=1)
    cart = ForeignKey("Cart", on_delete=CASCADE)
    active = BooleanField(default=True)

    def sub_total(self):
        return self.product.price * self.quantity

    def __str__(self):
        return self.product

carts/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.views.generic import (
    DetailView,
    ListView,
    CreateView,
    UpdateView,
    DeleteView,
)
from django.core.exceptions import ObjectDoesNotExist
from catalogue.models import Item
from .models import Cart, CartItem


def cart_id(request):
    cart = request.session.session_key
    if not cart:
        cart = request.session.create()
    return cart


def add_cart(request, item_id):
    product = Item.objects.get(id=item_id)
    cart, _ = Cart.objects.get_or_create(cart_id=cart_id(request), user=request.user)
    cart_item, created = CartItem.objects.get_or_create(product=product, cart=cart)

    if not created:
        cart_item.quantity += 1
        cart_item.save()

    return redirect("cart:cart_detail")


def cart_detail(request, total=0, counter=0, cart_items=None):
    try:
        cart = Cart.objects.get(cart_id=cart_id(request))
        cart_items = CartItem.objects.filter(cart=cart, active=True)
        for cart_item in cart_items:
            total += cart_item.product.price * cart_item.quantity
            counter += cart_item.quantity
    except ObjectDoesNotExist:
        pass
    return render(
        request, "cart.html", dict(cart_items=cart_items, total=total, counter=counter)
    )


def cart_remove(request, product_id):
    cart = Cart.objects.get(cart_id=cart_id(request))
    product = get_object_or_404(Item, id=product_id)
    cart_item = CartItem.objects.get(product=product, cart=cart)
    if cart_item.quantity > 1:
        cart_item.quantity -= 1
        cart_item.save()
    else:
        cart_item.delete()
    return redirect("cart:cart_detail")


def full_remove(request, product_id):
    cart = Cart.objects.get(cart_id=cart_id(request))
    product = get_object_or_404(Item, id=product_id)
    cart_item = CartItem.objects.get(product=product, cart=cart)
    cart_item.delete()
    return redirect("cart:cart_detail")

templates/about.html
{% extends "base.html" %}
{% load static %}

{% block content %}
<div class="text-decoration-none text-nowrap">
    <br>
    <br>
    <h4>
        Welcome to our new oldschool designed store!
    </h4>
    <br>
    <br>
    <p>
       <b> Our important long slogan:</b>
    </p>
    <p>
        Our goal is that you leave with less money than you initially came in with!
        We are offering today's technology with tomorrow price.
    </p>
    <br>
    <p>
        Thanks for supporting us. You are the reason why we are still here.
    </p>
</div>
    <div class="img-fluid">
    <a>
    <img src="{% static 'images/images.jpeg' %}" alt="about">
    </a>
    </div>
{% endblock content %}

templates/account_card.html
{% extends 'base.html' %}

{% block content %}
    {% if profile %}
        <h3> Your information about profile on MyEshop {{ profile.username|capfirst }} </h3>
        <br>
        <ul>
            {% if profile.email %}
                <li><b>Name:</b> {{ profile.first_name }} {{ profile.last_name }}</li>
            {% endif %}
        </ul>
        <br>
        <ul>
            {% if profile.personal_phone %}
                <li><b>Personal phone:</b> {{ profile.personal_phone }}</li>
            {% endif %}
        </ul>
        <br>
        <ul>
            {% if profile.email %}
                <li><b>E-mail:</b> {{ profile.email }}</li>
            {% endif %}
        </ul>
        <br>
        <ul>
            {% if profile.address %}
                <li><b>Address:</b> {{ profile.address }}</li>
            {% endif %}
        <br>
        </ul>

        <a class="btn btn-primary btn-warning"
           href="">Edit contact
        </a>
    {% else %}
        <h1>Contact details - <b>unknown contact</b></h1>

    {% endif %}
{% endblock %}

templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>My eShop</title>
    <link rel="stylesheet" href="{% static 'css/styles.css' %}">
    <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}">
    <link rel="stylesheet" href="{% static 'css/fontawesome-all.min.css' %}">
    <link href="https://fonts.googleapis.com/css?family=Tangerine">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css" integrity="sha512-1ycn6IcaQQ40/MKBW2W4Rhis/DbILU74C1vSrLJxCq57o941Ym01SwNsOMqvEBFlcgUa6xLiPY/NS5R+E6ztJQ==" crossorigin="anonymous" referrerpolicy="no-referrer" />

    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
            integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
            crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.6/umd/popper.min.js"
            integrity="sha384-wHAiFfRlMFy6i5SRaxvfOCifBUQy1xHdJ/yoi7FRNXMRBu5WHdZYu1hA6ZOblgut"
            crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.2.1/js/bootstrap.min.js"
            integrity="sha384-B0UglyR+jN6CkvvICOB2joaf5I4l3gm9GU6Hc1og6Ls7i6U/mkkaduKaBhlAXv9k"
            crossorigin="anonymous"></script>
</head>
<body>

<nav class="navbar navbar-expand-lg navbar-light bg-light">
<div class="container-fluid">
    <div class="collapse navbar-collapse" style="font-size: 18px">
        <div class="logo">
            <a href="{% url 'item_list' %}">
            <img src="{% static 'images/logo.png' %}" alt="logo" width="200">
            </a>
        </div>
        <nav>
            <ul>
                <li><a href="{% url 'item_list' %}"><i class="fas fa-home"></i>Home</a></li>
                <li><a href="{% url 'about' %}">About</a></li>

                {# --- Nav menu for logged user --- #}
                {% if request.user.is_authenticated %}
                <li><a href="{% url 'accounts:view_profile' %}"><i class="fas fa-user"></i>My account</a></li>
                <li><a href=" {%  url 'cart:cart_detail' %}"><i class="fas fa-shopping-cart"></i>Cart{{item_count}}</a></li>
                <li><a href="{% url 'accounts:logout_request' %}"><i class="fas fa-sign-out-alt"></i>Log Out</a></li>

                {# --- not logged user --- #}
                {% else %}
                <li><a href="{% url 'accounts:login' %}">Login</a></li>
                <li><a href="{% url 'accounts:sign_up' %}"><i class="fas fa-sign-in-alt"></i>Sign up</a></li>
                {% endif %}


            </ul>
        </nav>
    </div>
</div>
</nav>
<div class="container">
    <div class="jumbotron">
        {% block content %}{% endblock %}
    </div>
</div>
</body>
</html>

templates/card.html
{% load humanize %}
<div class="wrapper">
    <div class="card-sl flex-container">
        <div class="card-image">
            {% if item.image %}
               <a href="{% url 'product' item.id %}"> <img  src="{{ item.image.url }}" class="card-img-top" alt="Product image">
                </a>
            {% endif %}
        </div>
        <div class="card-heading" href="{% url 'product' item.id %}">
            {{ item.item_name }}
        </div>
        <div class="card-text" href="{% url 'product' item.id %}">
            {{ item.description_catalogue }}
        </div>
        <div class="card-price" href="{% url 'product' item.id %}">
            <p>{{ item.price|intcomma }} CZK </p>
        </div>
        <div class="card-button card-footer">
            <a href="{% url 'cart:add_cart' item.id %}"> Add to cart</a>
        </div>
    </div>
</div>

templates/cart.html
{% extends "base.html" %}
{% load humanize %}
{% block metadescription %}
    This is the shopping cart page. Proceed to review your items and place the order.
{% endblock %}
{% block title %}
    Cart - MyEshop
{% endblock %}
{% block content %}
    {% if not cart_items %}
        <div>
            <div class="text-center">
                <br>
                <h1 class="text-center my_title">
                    Your shopping cart is empty
                </h1>
                <br>
                <p class="text-center">
                    Please click <a href="{% url 'item_list' %}">here</a> to continue shopping.
                </p>
            </div>
        </div>
    {% else %}
        <div>
            <div class="text-center">
                <br>
                <h1 class="text-center my_title">
                    Your shopping cart
                </h1>
                <br>
            </div>
        </div>
        <div class="row mx-auto">
            <div class="col-12 col-sm-12 col-md-12 col-lg-6 text-center">
                <table class="table my_custom_table">
                    <thead class="my_custom_thead">
                    <tr>
                        <th colspan="5">
                            Your items
                        </th>
                    </tr>

                    </thead>
                    <tbody>
                    {% for cart_item in cart_items %}
                        <tr>
                            <td>
                                <a href="{{ cart_item.product.get_url }}"><img src="{{ cart_item.product.image.url }}"
                                                                               alt=""
                                                                               class="float-left rounded custom_image"></a>
                            </td>
                            <td class="text-left">
                                {{ cart_item.product.item_name }}
                                <br>
                                Product ID: {{ cart_item.product.id }}
                                <br>
                                Price: {{ cart_item.product.price|intcomma }} CZK
                                <br>
                                Qty: {{ cart_item.quantity }} x {{ cart_item.product.price|intcomma }} CZK
                            </td>
                            <td>
                                Price: {{ cart_item.sub_total|intcomma }} CZK
                            </td>
                            {% if cart_item.quantity < cart_item.product.count_in_stock %}
                                <td>
                                    <a href="{% url 'cart:add_cart' cart_item.product.id %}" class="custom_a"><i
                                            class="fas fa-plus-circle custom_icon"></i></a>&nbsp;<a
                                        href="{% url 'cart:cart_remove' cart_item.product.id %}" class="custom_a"><i
                                        class="fas fa-minus-circle custom_icon"></i></a>&nbsp;<a
                                        href="{% url 'cart:full_remove' cart_item.product.id %}" class="custom_icon"><i
                                        class="fas fa-trash-alt custom_icon"></i></a>
                                </td>
                            {% else %}
                                <td>
                                    &nbsp;<a href="{% url 'cart:cart_remove' cart_item.product.id %}"
                                             class="custom_a"><i
                                        class="fas fa-minus-circle custom_icon"></i></a>&nbsp;<a
                                        href="{% url 'cart:full_remove' cart_item.product.id %}" class="custom_icon"><i
                                        class="fas fa-trash-alt custom_icon"></i></a>
                                </td>
                                <td></td>
                            {% endif %}
                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
                <tr>
                    <td class="text-left">
                        Your total is: <strong>{{ total|intcomma }}CZK</strong>
                    </td>
                </tr>
            </div>
        </div>
        <br>
        <div class="col-12 col-sm-12 col-md-12 col-lg-6 text-center">
        <table class="table my_custom_table">
            <thead class="my_custom_thead">
            <tr>
                <th>
                    Checkout
                </th>
            </tr>
            </thead>
            <tbody>
            <tr>
                <td>
                    Please review your shopping cart items before proceeding with the order payment.
                </td>
            </tr>
            </tbody>
        </table>
    {% endif %}
</div>
{% endblock %}

templates/form.html
{% extends "base.html" %}

{% block content %}
    <form method="POST">
    {% csrf_token %}
    <table>{{ form }}</table>
    <input type="submit" value="Submit" class="btn btn-primary">
    </form>
{% endblock %}

templates/item_list.html
{% extends "base.html" %}


{% block content %}

    <div class="wrapper " style="margin: 10px">
        {% for item in items %}
            {% include 'card.html' %}
        {% endfor %}
    </div>
{% endblock content %}

templates/product_detail.html
{% extends "base.html" %}
{% load humanize  %}
{% block metadescription %}
	{{ item.description|truncatewords:155 }}
{% endblock %}
{% block title %}
	{{ product.name }} - MyEshop
{% endblock %}
{% block content %}
	<div class="row my_prod_row_class">
		<div class="container">
			<br>
			<div class="row">
				<div class="col-12 col-sm-12 col-md-12 col-lg-7">
					<div style="min-width: 14rem;">
						<img style="max-width: 600px" src="{{item.image.url}}" alt="{{item.item_name}}">
					</div>
				</div>
				<div class="col-12 col-sm-12 col-md-12 col-lg-5">
					<div>
						<h1 class="my_prod_title">{{item.item_name}}</h1>
						<p>{{item.price|intcomma}} CZK</p>
						<p class="my_title">Product Description</p>
						<p class="text-justify my_prod_text">{{item.description}}</p>
						{% if product.stock <= 0 %}
							<p class="text-justify my_prod_text"><b>Out of Stock</b></p>
						{% else %}
							<a class="btn btn-secondary" href="{% url 'cart:add_cart' item.id %}">Add to Cart</a>
						{% endif %}
					</div>
				</div>
			</div>
		</div>
	</div>
{% endblock %}